<?php
// $Id: address.inc,v 1.1.2.5 2007/12/19 08:46:24 brmassa Exp $
/**
 * @author e-Commerce Dev Team
 * @file address.inc
 * All function that are not hooks
 */

/**
 * Module Settings
 *
 * @param $form
 *   Array, the Seetings form
 */
function _address_admin() {
  $form = array();

  // Get all countries
  include_once drupal_get_path('module', 'store') .'/store.localization.inc';
  $countries = _store_build_countries();

  $form['ec_address_countries'] = array(
    '#default_value' => variable_get('ec_address_countries', array_keys($countries)),
    '#description'   => t('What countries your users can choose?'),
    '#multiple'      => TRUE,
    '#options'       => $countries,
    '#title'         => t('Countries'),
    '#type'          => 'select'
  );
  $form['ec_address_address2'] = array(
    '#default_value' => variable_get('ec_address_address2', TRUE),
    '#description'   => t('A second address line needed?'),
    '#title'         => t('Second Address Line'),
    '#type'          => 'checkbox'
  );
//   $form['ec_address_address3'] = array(
//     '#default_value' => variable_get('ec_address_address3', FALSE),
//     '#description'   => t('A third address line needed?'),
//     '#title'         => t('Third Address Line'),
//     '#type'          => 'checkbox'
//   );
  $form['ec_address_zip'] = array(
    '#default_value' => variable_get('ec_address_zip', TRUE),
    '#description'   => t('The ZIP code is needed?'),
    '#title'         => t('ZIP code'),
    '#type'          => 'checkbox'
  );
  $form['ec_address_phone1'] = array(
    '#default_value' => variable_get('ec_address_phone1', TRUE),
    '#description'   => t('Phone number needed?'),
    '#title'         => t('Phone Number'),
    '#type'          => 'checkbox'
  );
//   $form['ec_address_phone2'] = array(
//     '#default_value' => variable_get('ec_address_phone2', array_keys($countries)),
//     '#description'   => t('A second phone number needed?'),
//     '#title'         => t('Second Phone Number'),
//     '#type'          => 'checkbox'
//   );

  return system_settings_form($form);
}

/**
 * Insert the address fields to the form.
 *
 * @param $edit
 *   Array (optional), the current form array
 *
 * @ingroup form
 */
function _address_form($edit = array()) {
  if (!empty($edit['country']) and is_numeric($edit['country'])) {
    // alert users with old-style addresses
    drupal_set_message(t('Please update your <em>country</em> and <em>state/province</em>. We apologize for the inconvenience.'));
  }

  include_once drupal_get_path('module', 'store') .'/store.localization.inc';
  $countries = _store_build_countries();
  $countries_list = variable_get('ec_address_countries', $countries);
  foreach ($countries as $country_code => $country_name) {
    if (empty($countries_list[$country_code])) {
      unset($countries[$country_code]);
    }
  }
  array_unshift($countries, t('Please choose...'));
  $country = (!empty($edit['country']) ? $edit['country'] : variable_get('ec_country', 0));

  $form['firstname'] = array(
    '#type'           => 'textfield',
    '#title'          => t('First Name'),
    '#default_value'  => !empty($edit['firstname']) ? $edit['firstname'] : '',
    '#size'           => 50,
    '#maxlength'      => 75,
    '#required'       => true
  );
  $form['lastname'] = array(
    '#type'           => 'textfield',
    '#title'          => t('Last Name'),
    '#default_value'  => !empty($edit['lastname']) ? $edit['lastname'] : '',
    '#size'           => 50,
    '#maxlength'      => 75,
    '#required'       => true
  );
  $form['country'] = array(
    '#type'               => 'select',
    '#title'              => t('Country'),
    '#default_value'      => $country,
    '#options'            => $countries,
    '#required'           => true
  );
  // Use AJAX to autocomplete based on current country
  $form['state'] = array(
    '#autocomplete_path'  => 'address/autocomplete',
    '#type'               => 'textfield',
    '#title'              => t('State / Province'),
    '#default_value'      => $edit['state'],
    '#size'               => 30,
    '#maxlength'          => 64
  );
  $form['city'] = array(
    '#type'           => 'textfield',
    '#title'          => t('City'),
    '#default_value'  => !empty($edit['city']) ? $edit['city'] : '',
    '#size'           => 30,
    '#maxlength'      => 64,
    '#required'       => true
  );
  $form['street1'] = array(
    '#type'           => 'textfield',
    '#title'          => t('Address Line 1'),
    '#default_value'  => !empty($edit['street1']) ? $edit['street1'] : '',
    '#size'           => 50,
    '#maxlength'      => 75,
    '#required'       => true
  );
  if (variable_get('ec_address_address2', TRUE)) {
    $form['street2'] = array(
      '#type'           => 'textfield',
      '#title'          => t('Address Line 2'),
      '#default_value'  => !empty($edit['street2']) ? $edit['street2'] : '',
      '#size'           => 50,
      '#maxlength'      => 75
    );
  }
  if (variable_get('ec_address_zip', TRUE)) {
    $form['zip'] = array(
      '#type'           => 'textfield',
      '#title'          => t('Zip / Postal Code'),
      '#default_value'  => !empty($edit['zip']) ? $edit['zip'] : '',
      '#size'           => 20,
      '#maxlength'      => 20
    );
  }
  if (variable_get('ec_address_phone1', TRUE)) {
    $form['phone'] = array(
      '#type'           => 'textfield',
      '#title'          => t('Phone Number'),
      '#default_value'  => !empty($edit['phone']) ? $edit['phone'] : '',
      '#size'           => 50,
      '#maxlength'      => 100,
    );
  }

  if (!empty($edit['aid'])) {
    $form['aid'] = array('#type' => 'value', '#value' => $edit['aid']);
  }
  if (!empty($edit['uid'])) {
    $form['uid'] = array('#type' => 'value', '#value' => $edit['uid']);
  }

  if (!empty($edit['aid'])) {
    $form['submit'] = array(
      '#type'   => 'submit',
      '#value'  => t('Update address')
      );
  }
  else {
    $form['submit'] = array(
      '#type'   => 'submit',
      '#value'  => t('Create new address')
    );
  }

  return $form;
}

/**
 * Validate an address being saved
 */
function _address_form_validate($form_id, $form_values) {
  if ( variable_get('store_ignore_state', false)) {
    return;
  }

  include_once drupal_get_path('module', 'store') .'/store.localization.inc';
  if ($states = _store_build_states($form_values['country']) and
      empty($states[$form_values['state']])) {
    form_set_error('state', t('Invalid state. Try to use the state code.'));
  }
}

/**
 * Submit an address being saved
 */
function _address_form_submit($form_id, $form_values) {
  $aid = $form_values['aid'];

  if (empty($form_values['uid'])) {
    global $user;
    $form_values['uid'] = $user->uid;
  }
  $fields = address_fields();

  if (!empty($aid)) {
    foreach ($form_values as $key => $value) {
      if (in_array($key, $fields)) {
        $q[] = db_escape_string($key) ." = '%s'";
        $v[] = $value;
      }
    }
    db_query('UPDATE {ec_address} SET '. implode(', ', $q) .
      " WHERE aid = $aid", $v);
  }
  else {
    foreach ($form_values as $key => $value) {
      if (in_array($key, $fields)) {
        $k[] = db_escape_string($key);
        $v[] = $value;
        $s[] = "'%s'";
      }
    }
    db_query('INSERT INTO {ec_address} ('. implode(', ', $k) .')
      VALUES('. implode(', ', $s) .')', $v);
  }

  drupal_set_message(t('The address has been saved.'));
  return "user/{$form_values['uid']}/address";
}

/**
 * Format the Address form
 *
 * @ingroup themeable
 */
function theme__address_form($form_values) {
  // Add the javascript to give some AJAX power
  drupal_add_js(drupal_get_path('module', 'address') .'/address.js', 'module');

  return drupal_render($form_values);
}