<?php
// $Id: ec_charge.inc,v 1.1.2.1 2007/12/18 06:03:19 brmassa Exp $
/**
 * @author e-Commerce Dev Team
 * @file ec_charge.inc
 *   API to let users to apply custom charges and discounts
 *   based on a group of rules, like user role, location,
 *   product type.
 */

/**
 * Load all charges or a specific one
 *
 * @param #child
 *   Number, the Charge ID
 * @return
 *   Array, the charge(s) data
 */
function _ec_charge_load_charges($chid = NULL) {
  $result = $charges = array();
  if (!empty($chid)) {
    $result = db_query('SELECT chid, provider, method, display, operator,
      rate, position, subtotal_before, subtotal_after, hide_if_zero,
      already_added, ptypes, roles, settings FROM {ec_charge}
      WHERE chid = %d ORDER BY position', $chid);
  }
  else {
    $result = db_query('SELECT chid, provider, method, display, operator,
      rate, position, subtotal_before, subtotal_after, hide_if_zero,
      already_added, ptypes, roles, settings FROM {ec_charge}
      ORDER BY position');
  }
  while ($charge = db_fetch_object($result)) {
    $charges[$charge->chid] = $charge;
    $charges[$charge->chid]->settings = unserialize($charge->settings);
    $charges[$charge->chid]->ptypes = unserialize($charge->ptypes);
    $charges[$charge->chid]->roles = unserialize($charge->roles);
  }
  return (!empty($chid) and !empty($charges[$chid])) ? $charges[$chid] : $charges;
}

/**
 * Returns an array of ec_charge method files.
 *
 * @return
 *   Array, the method files
 */
function _ec_charge_partners() {
  // Locate the subdirectory holding partner include files.
  $partner_dir = drupal_get_path('module', 'ec_charge');

  // Locate all partner include files.
  $files = file_scan_directory($partner_dir, '\.inc$');

  $partners = array();
  foreach ($files as $partner) {
    include_once($partner->filename);
    $partners[$partner->name] = $partner;
  }
  return $partners;
}
