<?php
// $Id: shipping.dimensions.inc,v 1.1.2.3 2007/12/19 08:22:37 brmassa Exp $
/**
 * @file shipping.dimensions.inc
 * Centralize the product physical dimension functions
 */

/**
 * Create the dimensions form fields
 *
 * @param &$form
 *   Array, the form array
 * @param $dimensions
 *   Array, which physical dimensions are needed
 * @return
 *   Array, the form field arrays
 */
function _shipping_dimensions_form(&$form, $dimensions) {
  array_unshift($dimensions, '--');
  $dimensions = array_flip($dimensions);
  $fields     = array();

//   $fields['dimensions'] = array(
//     '#collapsible'    => TRUE,
//     '#tree'           => FALSE,
//     '#title'          => t('Dimensions'),
//     '#type'           => 'fieldset'
//   );

  // Check for Weight
  if (!empty($dimensions['weight'])) {
    $fields['weight'] = array(
      '#default_value'  => $form['#node']->product_attributes['weight'],
      '#required'       => TRUE,
      '#size'           => 15,
      '#title'          => t('Weight (in %unit)', array('%unit' => store_name_measure('weight'))),
      '#type'           => 'textfield',
    );
  }

  // Check for Lenght, Height and Width
  if (!empty($dimensions['length'])) {
    $fields['length'] = array(
      '#default_value'  => $form['#node']->product_attributes['length'],
      '#required'       => TRUE,
      '#size'           => 5,
      '#title'          => t('Length (in %unit)', array('%unit' => store_name_measure('length'))),
      '#type'           => 'textfield'
    );
  }
  if (!empty($dimensions['height'])) {
    $fields['height'] = array(
      '#default_value'  => $form['#node']->product_attributes['height'],
      '#required'       => TRUE,
      '#size'           => 5,
      '#title'          => t('Height (in %unit)', array('%unit' => store_name_measure('length'))),
      '#type'           => 'textfield'
    );
  }
  if (!empty($dimensions['width'])) {
    $fields['width'] = array(
      '#default_value'  => $form['#node']->product_attributes['width'],
      '#required'       => TRUE,
      '#size'           => 5,
      '#title'          => t('Width (in %unit)', array('%unit' => store_name_measure('length'))),
      '#type'           => 'textfield'
    );
  }

  return $fields;
}